package tech.nostrum.qr_code

import androidx.annotation.NonNull
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.embedding.engine.plugins.activity.ActivityAware
import io.flutter.embedding.engine.plugins.activity.ActivityPluginBinding
import tech.nostrum.qr_code.Shared.activity

class NostrumQrPlugin : FlutterPlugin, ActivityAware {

    /** Plugin registration embedding v2 */
    override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
        if (activity != null) {
            activity = activity
        }
        flutterPluginBinding.platformViewRegistry
            .registerViewFactory(
                "tech.nostrum.qr_code/qrview", QRViewFactory(flutterPluginBinding.binaryMessenger))
    }

    override fun onDetachedFromEngine(binding: FlutterPlugin.FlutterPluginBinding) {
    }

    override fun onAttachedToActivity(activityPluginBinding: ActivityPluginBinding) {
        activity = activityPluginBinding.activity
        Shared.binding = activityPluginBinding
    }

    override fun onDetachedFromActivityForConfigChanges() {
        activity = null
        Shared.binding = null
    }

    override fun onReattachedToActivityForConfigChanges(activityPluginBinding: ActivityPluginBinding) {
        activity = activityPluginBinding.activity
        Shared.binding = activityPluginBinding
    }

    override fun onDetachedFromActivity() {
        activity = null
        Shared.binding = null
    }
    

}
